/*
 * Get the list of all rpc service names
 *
 * Copyright (C) 2000, <okir@caldera.de>
 */

#include <netdb.h>
#include <string.h>
#include "rpcent.h"

#define MAX_RPCNAMES	256
#define MAX_RPCNAMLEN	28
struct rpcname {
	char		name[MAX_RPCNAMLEN];
	unsigned int	number;
};

static struct rpcname	rpcname[MAX_RPCNAMES];

void
rpcname_init()
{
	struct rpcname	*np;
	struct rpcent	*ep;
	unsigned int	n;

	memset(rpcname, 0, sizeof(rpcname));

	setrpcent(1);
	np = rpcname;
	for (n = 0; n < MAX_RPCNAMES; n++, np++) {
		if ((ep = getrpcent()) == NULL)
			break;
		strncpy(np->name, ep->r_name, MAX_RPCNAMLEN-1);
		np->number = ep->r_number;
	}

	endrpcent();
}

const char *
rpcname_find(unsigned int number)
{
	struct rpcname	*np;
	unsigned int	n;

	np = rpcname;
	for (n = 0; n < MAX_RPCNAMES; n++, np++) {
		if (np->number == number)
			return np->name;
	}
	return NULL;
}
